/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2023 - 2024 Ben Burkhard, Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.business.shared.usergeneratedcontentflags.statistics;

import de.fhg.iese.dd.platform.business.shared.statistics.*;
import de.fhg.iese.dd.platform.datamanagement.shared.usergeneratedcontentflags.repos.UserGeneratedContentFlagRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.usergeneratedcontentflags.repos.results.UserGeneratedContentFlagSimpleCountByGeoArea;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collection;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@Component
public class FlagStatisticsProvider extends BaseStatisticsProvider {

    public static final String STATISTICS_ID_FLAGGED_CONTENT_COUNT = "shared.flagged-content.count";
    public static final String STATISTICS_ID_FLAGGED_CONTENT_COUNT_AUTOGENERATED = "shared.flagged-content.count.autogenerated";

    @Autowired
    private UserGeneratedContentFlagRepository userGeneratedContentFlagRepository;

    @Override
    public Collection<StatisticsMetaData> getAllMetaData() {
        Set<StatisticsMetaData> metaData = new HashSet<>();
        metaData.add(StatisticsMetaData.builder()
                .id(STATISTICS_ID_FLAGGED_CONTENT_COUNT)
                .machineName("flagged-content-count")
                .timeRelation(StatisticsTimeRelation.NEW)
                .timeRelation(StatisticsTimeRelation.TOTAL)
                .expectedWidth(6)
                .valueFormat("%d")
                .build());
        metaData.add(StatisticsMetaData.builder()
                .id(STATISTICS_ID_FLAGGED_CONTENT_COUNT_AUTOGENERATED)
                .machineName("flagged-content-count-autogenerated")
                .timeRelation(StatisticsTimeRelation.NEW)
                .timeRelation(StatisticsTimeRelation.TOTAL)
                .expectedWidth(6)
                .valueFormat("%d")
                .build());
        return metaData;
    }

    @Override
    public void calculateGeoAreaStatistics(Collection<GeoAreaStatistics> geoAreaInfos,
            StatisticsReportDefinition definition) {

        querySummingStatistics(userGeneratedContentFlagRepository::countTotalByGeoAreaId, Map.of(
                        STATISTICS_ID_FLAGGED_CONTENT_COUNT,
                        UserGeneratedContentFlagSimpleCountByGeoArea::getUserGeneratedContentFlagCount),
                geoAreaInfos, definition);
        querySummingStatistics(userGeneratedContentFlagRepository::countFlagCreatorNullTotalByGeoAreaId, Map.of(
                        STATISTICS_ID_FLAGGED_CONTENT_COUNT_AUTOGENERATED,
                        UserGeneratedContentFlagSimpleCountByGeoArea::getUserGeneratedContentFlagCount),
                geoAreaInfos, definition);
    }

}
